% dati [a b], y(a), f(x,y), n, theta, calcola la soluzione
% di un problema di Cauchy con il theta-metodo
% il metodo implicito e' risolto con un metodo di punto fisso
%
% in uscita ci sono le ascisse dei nodi e i valori
% della soluzione
%
function [x,eta]=thmetodo(a,b,y0,f,n,th)
kmax=100; % iterazioni interne che sono disposto a pagare
tol=1e-5; % test di arresto per il punto fisso
h=(b-a)/n;
eta=zeros(1,n+1);
eta(1)=y0;
x=(a:h:b);
if th==0
  [x,eta]=eulesp(a,b,y0,f,n);
else
    for i=1:n
        f1=f(x(i),eta(i));
        etak=eta(i);
        for k=1:kmax
            f2=f(x(i+1),etak);
            etak2=eta(i)+h*((1-th)*f1+th*f2);
            if abs(etak2-etak)<tol
                break
            end
            etak=etak2;
        end
        if k>=kmax
            disp('Raggiunto numero massimo di iterazioni')
        end
        eta(i+1)=etak2;
    end
end
plot(x,eta,'-o');
